<?php

declare(strict_types=1);
/**
 * .
 *
 * @link     https://www.hyperf.io
 * @document https://doc.hyperf.io
 * @contact  group@hyperf.io
 * @license  https://github.com/hyperf-cloud/hyperf/blob/master/LICENSE
 */

namespace Jlzan1314\Cache\Listener;

use Swoft\Event\Event;
use Jlzan1314\Cache\CacheEvent;

class DeleteEvent extends Event
{
    protected $className;
    protected $method;

    public function __construct(string $className, string $method, array $arguments)
    {
    	parent::__construct(CacheEvent::DELETE_EVENT,$arguments);
        $this->className = $className;
        $this->method = $method;
    }

    public function getClassName(): string
    {
        return $this->className;
    }

    public function getMethod(): string
    {
        return $this->method;
    }


	public function setParams(array $params): void
	{
		if (!$params) {
			return;
		}
		parent::setParams($params); // TODO: Change the autogenerated stub
	}

}
